[<prev] [next>] [thread-next>] [day] [month] [year] [list]
Message-Id: <4d3ab1f17230f0188698cfbc7ba08696fe1abfe9.1650474927.git.jpoimboe@redhat.com>
Date: Wed, 20 Apr 2022 10:16:36 -0700
From: Josh Poimboeuf <jpoimboe@...hat.com>
To: Peter Zijlstra <peterz@...radead.org>
Cc: linux-kernel@...r.kernel.org, x86@...nel.org,
Miroslav Benes <mbenes@...e.cz>, Borislav Petkov <bp@...en8.de>
Subject: [PATCH v3] scripts: Create objdump-func helper script
Add a simple script which disassembles a single function from an object
file. Comes in handy for objtool warnings and kernel stack traces.
Originally-by: Peter Zijlstra <peterz@...radead.org>
Signed-off-by: Josh Poimboeuf <jpoimboe@...hat.com>
---
v3:
- Add usage
- Fix vmlinux
scripts/objdump-func | 25 +++++++++++++++++++++++++
1 file changed, 25 insertions(+)
create mode 100755 scripts/objdump-func
diff --git a/scripts/objdump-func b/scripts/objdump-func
new file mode 100755
index 000000000000..0908f9f616c3
--- /dev/null
+++ b/scripts/objdump-func
@@ -0,0 +1,25 @@
+#!/bin/bash
+# SPDX-License-Identifier: GPL-2.0
+#
+# Disassemble a single function.
+#
+# usage: objdump-func <file> <func>
+
+set -o errexit
+set -o nounset
+
+OBJDUMP="${CROSS_COMPILE:-}objdump"
+
+command -v gawk >/dev/null 2>&1 || die "gawk isn't installed"
+
+usage() {
+ echo "usage: objdump-func <file> <func>" >&2
+ exit 1
+}
+
+[[ $# -ne 2 ]] && usage
+
+OBJ=$1; shift
+FUNC=$1; shift
+
+${OBJDUMP} -wdr $OBJ | gawk -M -v f=$FUNC '/^$/ { P=0; } $0 ~ "<" f ">:" { P=1; O=strtonum("0x" $1); } { if (P) { o=strtonum("0x" $1); printf("%04x ", o-O); print $0; } }'
--
2.34.1
Powered by blists - more mailing lists